#include <string>
#include <fstream>
#include <map>
#include <openssl/ssl.h>
#define HTTP_HDR_MAX 1024*1024
class http_hdr
{
public:
	enum http_command
	{
		CM_MKCOL,
		CM_PUT,
		CM_PPATCH,
		CM_GET,
		CM_LOCK,
		CM_UNLOCK,
		CM_PFIND,
		CM_DELETE,
	};
	enum work_mode
	{
		CT_NORMAL,
		CT_FILEIN,
		CT_FILEOUT,
	}  mode;
	enum proto_ret 
	{
		HH_OK=0,
		HH_RETRY,
		HH_FAIL,
	};
	enum state 
	{
		WD_DISCONNECTED,
		WD_CONNECTED,
		WD_EPIPE,
	}
	conn_state;




	http_hdr();
	~http_hdr();
	http_hdr(http_command command, std::string filename);
	void add_body(const void* buf, size_t len);
	void parse_rcvd(std::string header);
	void add_lt(std::string lock_token);
	void add_file_body(std::ifstream* fd, size_t size);
	inline void add_file_rbody(std::ofstream* fd){ofd=fd; mode=CT_FILEOUT;};

	void connect();
	void disconnect();

	int process_request();
	proto_ret send();
	proto_ret recv();
	
	int pending();
	int _send(const void* buf, size_t len);
	int _recv(void* buf, size_t len);

	std::string toString();


	//FILES
	std::string fname;				//! Имя файла
	std::ifstream* ifd;
	std::ofstream* ofd;
	//IN
	std::string description;		//! Расшифровка статуса
	int status;				//!	Числовой статус ответа
	unsigned  more;				//!	Количество докачиваемых данных
	char* rdata;				//!     Указатель на принятые данные
	char* more_data;			//!     Указатель на докачку данных
	int cl;					//!	Размер данных в запросе
	unsigned  more_data_size;		//!	Размер уже принятых данных
	std::map<std::string,std::string> ivalues;	//!	Принимаемые значения
	std::string::size_type end;		//!	Конец ХТТП заголовка и начало данных
	//OUT
	std::string header;			//!	Отправляемый запрос верхняя строчка
	unsigned  data_size;			//!	Размер отправляемых данных
	char* data;				//!	Отправляемые данные
	std::map<std::string,std::string> values;	//! Отправляемые заголовки

	int sock;
	//SSL
	SSL_CTX* ssl_ctx;
	SSL* ssl;
	BIO* bio_err;
	BIO* sbio;

};


