#include <stdio.h>
#include <iostream>
#include <fstream>
#include <sstream>
#include <stdlib.h>
#include "config.h"
#include "sync.h"
#include "http_hdr.h"
#include "ipc_interface.h"
#include "ipc_proxy.h"
#include <libcfg.h>

#define HOME_ENV "HOME"
using namespace std;
http_ctx conn_ctx;

int main()
{
	try{
	//!Формируются пути к сокетам синхронизации
	char* he=getenv(HOME_ENV);
	if(!he)
		throw "Ошибка получения $HOME";
	string home(he);
	home+="/";home+=FOLDER_NAME;home+="/";
	string pathSync=home+SYNCRONIZE_PROGRAM_NAME;
	string pathNotify=home+NOTIFY_PROGRAM_NAME;
	string pathConfig=home+CONFIG_PROGRAM_NAME;
	string pathDolphin=home+DOLPHIN_PROGRAM_NAME;

	//! Создание классов
	config cfg(home+"cfg/");
/*	try{
		cfg=config(home+"psyncd.conf");
	}catch(...){
		cfg=config("psyncd.conf");
	}
*/	
	// Restore reqired parameters if needed
	if(cfg["server/address"].empty()) cfg.writeProperty("server/address","localhost");
	if(cfg["server/port"].empty()) cfg.writeProperty("server/port","9877");
	if(cfg["server/ssl"].empty()) cfg.writeProperty("server/ssl","yes");
	
	// Dump working configuration (for DEBUG purposes only)
        cout<<"cfg[server/address]="<<cfg["server/address"]<<"\n";
        cout<<"cfg[server/port]="<<cfg["server/port"]<<"\n";
        cout<<"cfg[server/ssl]="<<cfg["server/ssl"]<<"\n";
        cout<<"cfg[user/login]="<<cfg["user/login"]<<"\n";
        cout<<"cfg[user/password]="<<cfg["user/password"]<<"\n";
        cout<<"cfg[server/path]="<<string("/HTTP/")+cfg["/user/login"]+"/"<<"\n";
        
        // Set up working configuration
	syncronizer Sync(cfg["/server/address"],(unsigned short)atoi(cfg["/server/port"].c_str()),string("/HTTP/")+cfg["/user/login"]+"/");
	Sync.dbconnect(home+"sync.db");

	conn_ctx.host=cfg["/server/address"];	
	conn_ctx.path=string("/HTTP/")+cfg["/user/login"]+"/";	
	conn_ctx.port=(unsigned short)atoi(cfg["/server/port"].c_str());
	if(!cfg["user/login"].empty())
	{
		conn_ctx.creds=cfg["user/login"]+":"+cfg["user/password"];
	}

	if(cfg["server/ssl"].empty() || cfg["server/ssl"] == "no")
		conn_ctx.ssl=false;
	else
		conn_ctx.ssl=true;

	conn_ctx.home=home;
	conn_ctx.pathConfig=pathConfig;
	conn_ctx.pathNotify=pathNotify;

	ipc_proxy ipc(pathSync.c_str());
	unsigned tm=0;
	get_param_ui((conn_ctx.home+"cfg/user/").c_str(),"interval",&tm);
	conn_ctx.defFolder=cfg["/user/default_folder"];	
	Sync.setSyncTime(tm);
	Sync.setIPC(&ipc);
	conn_ctx.ipc=&ipc;
	Sync.start();
	while(1)
	{
		if(ipc.nextb())
		{
			cerr<<"ipc_nextberr"<<endl;	
			continue;
		}
		cerr<<"GET:"<<ipc.getState()<<endl;
		switch(ipc.getState())
		{
			case ipc_proxy::SYNC_START:
				Sync.syncAll();
				break;
			case ipc_proxy::SYNC_STOP:
				cerr<<"остановка синхронизации"<<endl;
				Sync.syncStop();
				break;
			case ipc_proxy::FILE_ADD:
				{
					cerr<<"Добавление файла"<<endl;
					istringstream files(string(ipc.getData()));
					string line;
					while ( std::getline ( files, line ) ) {
						Sync.addFile(line.c_str());
					}
				}
				break;
			case ipc_proxy::SYNC_STATUS:
				if(Sync.is_work()){
					ipc.send(ipc_proxy::SYNC_START, pathNotify.c_str());
					ipc.send(ipc_proxy::SYNC_START, pathConfig.c_str());
				} else {
					ipc.send(ipc_proxy::SYNC_STOP, pathNotify.c_str());
					ipc.send(ipc_proxy::SYNC_STOP, pathConfig.c_str());
				}
				break;

			case ipc_proxy::FILE_DEL:
				{
					cerr<<"Удаление файла"<<endl;
					istringstream files(ipc.getData());
					string line;
					while ( getline ( files, line ) ) {
						Sync.removeFile(line);
					}
				}
				break;
			case ipc_proxy::DIR_STATUS:
				{
					string fpath = ipc.getData();
					string ret = Sync.checkDir(fpath);
					ipc.send(ipc_proxy::DIR_STATUS, pathDolphin.c_str(), ret);
				}
				break;
			case ipc_proxy::PWD_CHANGED:
			case ipc_proxy::REQ_LOGIN:
				{
					cerr<<"Запрос логина пароля";
					conn_ctx.creds=ipc.getData();
					conn_ctx.path=string("/HTTP/")+conn_ctx.creds.substr(0,conn_ctx.creds.find(":"))+"/";	
					int ret;
					try{
						ret=Sync.TryAuth();
					}catch(...){
						ret=-1;
					}
					
					cerr<<":"<<ret;
					if(ret>299||ret<200)
						ipc.send(ipc_proxy::ACC_VALID, pathConfig.c_str(), "0");
					else		//if(ret<299>200)
						ipc.send(ipc_proxy::ACC_VALID, pathConfig.c_str(), "1");
				}
				break;
			case ipc_proxy::SET_CHANGED:
				{
					conn_ctx.host=cfg["/server/address"];	
					conn_ctx.path=string("/HTTP/")+cfg["/user/login"]+"/";	
					conn_ctx.port=(unsigned short)atoi(cfg["/server/port"].c_str());
					conn_ctx.creds=cfg["user/login"]+":"+cfg["user/password"];
					if(cfg["server/ssl"].empty() || cfg["server/ssl"] == "no")
						conn_ctx.ssl=false;
					else
						conn_ctx.ssl=true;
					conn_ctx.defFolder=cfg["/user/default_folder"];	
					unsigned tm=0;
					get_param_ui((conn_ctx.home+"cfg/user/").c_str(),"interval",&tm);
					Sync.setSyncTime(tm);
				}
				break;

			default:
				break;
		}
	}
	Sync.stop();
	return 0;
	}
	catch(const char* str)
	{
		cerr<<"Critical error: "<<str<<endl;
		return -1;
	}
}
